import { Compilation, IRDeclaration, IRSignature } from '../compilation';
export declare type Signature = 'match' | 'value' | 'span';
export declare abstract class Code {
    readonly signature: Signature;
    readonly cacheKey: string;
    readonly name: string;
    protected cachedDecl: IRDeclaration | undefined;
    constructor(signature: Signature, cacheKey: string, name: string);
    abstract build(ctx: Compilation): IRDeclaration;
    protected getSignature(ctx: Compilation): IRSignature;
    protected getParams(): ReadonlyArray<string>;
    protected setAttributes(decl: IRDeclaration): void;
}
