"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const constants_1 = require("../constants");
const base_1 = require("./base");
class Field extends base_1.Code {
    constructor(signature, cacheKey, name, field) {
        super(signature, cacheKey, name);
        this.field = field;
    }
    build(ctx) {
        if (this.cachedDecl !== undefined) {
            return this.cachedDecl;
        }
        const sig = this.getSignature(ctx);
        const fn = ctx.defineFunction(sig, this.name, this.getParams());
        this.setAttributes(fn);
        this.doBuild(ctx, fn.body);
        this.cachedDecl = fn;
        return fn;
    }
    setAttributes(decl) {
        super.setAttributes(decl);
        decl.attrs.add(constants_1.FN_ATTR_CODE);
        decl.cconv = constants_1.CCONV;
        decl.linkage = constants_1.LINKAGE;
    }
}
exports.Field = Field;
//# sourceMappingURL=field.js.map