"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../utils");
const field_value_1 = require("./field-value");
class IsEqual extends field_value_1.FieldValue {
    constructor(name, field, value) {
        super('match', `is_equal_${field}_${utils_1.toCacheKey(value)}`, name, field, value);
    }
    doBuild(ctx, bb) {
        const value = bb.load(ctx.stateField(bb, this.field));
        const result = bb.icmp('eq', value, value.ty.val(this.value));
        bb.ret(ctx.truncate(bb, result, bb.parent.ty.toSignature().returnType));
    }
}
exports.IsEqual = IsEqual;
//# sourceMappingURL=is-equal.js.map