"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../utils");
const field_value_1 = require("./field-value");
class Or extends field_value_1.FieldValue {
    constructor(name, field, value) {
        super('match', `or_${field}_${utils_1.toCacheKey(value)}`, name, field, value);
    }
    doBuild(ctx, bb) {
        const ptr = ctx.stateField(bb, this.field);
        const field = bb.load(ptr);
        const result = bb.binop('or', field, field.ty.val(this.value));
        bb.store(result, ptr);
        bb.ret(bb.parent.ty.toSignature().returnType.toInt().val(0));
    }
}
exports.Or = Or;
//# sourceMappingURL=or.js.map