"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../utils");
const field_value_1 = require("./field-value");
class Test extends field_value_1.FieldValue {
    constructor(name, field, value) {
        super('match', `test_${field}_${utils_1.toCacheKey(value)}`, name, field, value);
    }
    doBuild(ctx, bb) {
        const field = bb.load(ctx.stateField(bb, this.field));
        const masked = bb.binop('and', field, field.ty.toInt().val(this.value));
        const bool = bb.icmp('eq', masked, field.ty.toInt().val(this.value));
        bb.ret(ctx.truncate(bb, bool, bb.parent.ty.toSignature().returnType));
    }
}
exports.Test = Test;
//# sourceMappingURL=test.js.map