import { Compilation, IRBasicBlock, IRDeclaration, IRValue } from '../compilation';
import { IUniqueName } from '../utils';
export interface INodeEdge {
    readonly node: Node;
    readonly noAdvance: boolean;
    readonly value: number | undefined;
}
export interface INodePosition {
    readonly current: IRValue;
    readonly next: IRValue;
}
export declare abstract class Node {
    readonly id: IUniqueName;
    protected otherwise: INodeEdge | undefined;
    private privCompilation;
    private cachedDecl;
    private tailMap;
    constructor(id: IUniqueName);
    setOtherwise(node: Node, noAdvance: boolean): void;
    build(ctx: Compilation): IRDeclaration;
    protected abstract doBuild(bb: IRBasicBlock, pos: INodePosition): void;
    protected readonly compilation: Compilation;
    protected prologue(bb: IRBasicBlock, pos: INodePosition): IRBasicBlock;
    protected pause(bb: IRBasicBlock): void;
    protected tailTo(bb: IRBasicBlock, edge: INodeEdge, pos: INodePosition): void;
}
