/// <reference types="node" />
import { IRBasicBlock } from '../compilation';
import { MatchSequence } from '../match-sequence';
import { IUniqueName } from '../utils';
import { INodePosition, Node } from './base';
import { Match } from './match';
export interface ISequenceEdge {
    readonly node: Node;
    readonly value: number | undefined;
}
export declare class Sequence extends Match {
    private readonly matchSequence;
    private readonly select;
    private edge;
    constructor(id: IUniqueName, matchSequence: MatchSequence, select: Buffer);
    setEdge(node: Node, value: number | undefined): void;
    protected doBuild(bb: IRBasicBlock, pos: INodePosition): void;
}
