"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const base_1 = require("./base");
class SpanStart extends base_1.Node {
    constructor(id, span, callback) {
        super(id);
        this.span = span;
        this.callback = callback;
    }
    doBuild(bb, pos) {
        // Prevent spurious empty spans
        bb = this.prologue(bb, pos);
        const ctx = this.compilation;
        const span = this.span;
        bb.store(ctx.posArg(bb), ctx.spanPosField(bb, span.index));
        if (span.callbacks.length > 1) {
            bb.store(this.callback.build(ctx), ctx.spanCbField(bb, span.index));
        }
        this.tailTo(bb, this.otherwise, pos);
    }
}
exports.SpanStart = SpanStart;
//# sourceMappingURL=span-start.js.map