import { ISpanAllocatorResult, node as api } from 'llparse-builder';
import * as compiler from '../node';
import { Span } from '../span';
export interface ITranslatorLazyOptions {
    readonly maxTableElemWidth?: number;
    readonly minTableSize?: number;
}
export declare class Translator {
    private readonly prefix;
    readonly spans: ReadonlyArray<Span>;
    private readonly options;
    private readonly id;
    private readonly codeId;
    private readonly map;
    private readonly spanMap;
    private readonly codeCache;
    private readonly matchSequenceCache;
    constructor(prefix: string, options: ITranslatorLazyOptions, spans: ISpanAllocatorResult);
    translate(node: api.Node): compiler.Node;
    private translateMatch;
    private translateTrie;
    private translateSingle;
    private maybeTableLookup;
    private translateSequence;
    private translateCode;
    private translateTransform;
    private createMatchSequence;
}
